var express = require('express');
var router = express.Router();
var configs = require('./configs');
var request = require('request');
var Bootstrap = require('./Bootstrap');
var querystring = require('querystring');
var cookie = require('cookie');
var fs = require('fs');

function extend(obj, src) {
    Object.keys(src).forEach(function(key) { obj[key] = src[key]; });
    return obj;
}

module.exports =  function(req, res, next) {
	var conf = configs.get('api');
	var data = req.query;
	var additions = req.session.additions || {};
	data = extend(data, additions);
	data.app_id = conf.client_id;
	data.ip = req.ip;
	data.access_token = Bootstrap.getAccessToken();
	var paramsString = querystring.stringify(data);
	var options = {
		url: conf.secret_url + req.path + '?' + paramsString, 
		method: req.method,
		headers: {
			cookie: req.headers.cookie
		}
	};
	
	// console.log(options);
	var r = request(options, function (error, response, body) {
		// if (error || response.statusCode != 200){
		// 	console.log(response.statusCode);
		// 	res.json({a: response.statusCode});	
		// }
		if (!error && response.statusCode == 200) {
			var responseType = response.headers['content-type'];
			console.log('responseType');
			console.log(responseType);
			console.log('responseType');
			var cookies = response.headers['set-cookie'] || {};
			// set cookies
			for (var i = cookies.length - 1; i >= 0; i--) {
				var cook = cookie.parse(cookies[i]);
				var cookName = Object.keys(cook)[0];
				res.cookie(cookName, cook[cookName], { maxAge: 900000, httpOnly: true });
			};
			if (responseType == 'application/json') {
			
				// res.json(JSON.parse(body));
				// res.send(body);	
				
			} else if (responseType == 'text/html'){

				res.send(body);	
				
			}
			else {
				// it's probably file response
				// so we will try to download it
				// var file = fs.createWriteStream("file.jpg");
				var regexp = /filename=\"(.*)\"/gi;
				var filename = regexp.exec( response.headers['content-disposition'] )[1];
				var path = __dirname+ '/../../uploads/' + filename;
				var fws = fs.createWriteStream( path );
				console.log(path);
				fws.write(body);
				fws.end();

                    // setup piping
                    // res.pipe(fws);
				res.download(path);	
			};
		} 

	});
	var form = r.form();

	// handle all the POST/PUT/DELETE shit
	if (req.method != 'GET') {
		var files = req.files || {};
		files.map(function(file, index){
			form.append('files[]', file.buffer, {
		  		filename: file.originalname,
		  		contentType: file.mimetype
			});
		});
		var bodyFields = req.body || {};
		for (var key in bodyFields) {
		  	form.append(key, bodyFields[key]);
		}
	};
}